﻿local ADDONNAME, RepperData = ...
local VERSION = GetAddOnMetadata(ADDONNAME,"Version")
RepperData.Functions = {}
local MyFuncs = RepperData.Functions;
local _;

-- Variables
local AllFactions = {};
local FactionsByName = {};
local TrackingConfig = {nil, ScrollFrame = nil, ScrollChild = nil};
local VariablesLoaded = false;
local waitTable = {};
local waitFrame = nil;
-- Slash Commands
SLASH_Repper1 = '/repper'

function Repper_OnLoad(self)
	self:RegisterEvent("ADDON_LOADED");						--AddOn Loaded
	self:RegisterEvent("PLAYER_ENTERING_WORLD");			--Player Loaded
	self:RegisterEvent("CHAT_MSG_COMBAT_FACTION_CHANGE");	--Faction Update
	self:RegisterEvent("CHAT_MSG_SYSTEM");					--New Faction Added
end
-- Event Handler
function Repper_OnEvent(self, event, ...)
	-- Starts the addon
	if (event == "ADDON_LOADED") then
		if (...) == ADDONNAME then
			DEFAULT_CHAT_FRAME:AddMessage("|cff00ff00"..ADDONNAME.." ".."|cffff0000"..VERSION.."|cff00ff00: Loaded.");
			MyFuncs.Initialize();
		end
	-- Fires on Enter World
	elseif (event == "PLAYER_ENTERING_WORLD" ) then
		VariablesLoaded = true;
		MyFuncs.Update()
	-- Fires on other update events
	else
		Repper_wait(1,MyFuncs.Update())
		print(#AllFactions)
		print(GetNumFactions())
	end
end

-- Initial UIObject Setup
 function MyFuncs.Initialize()
	if (RepperSVPC == nil) then RepperSVPC = {} else FactionsByName = RepperSVPC end;
	--Create Config Frame
	TrackingConfig = CreateFrame("Frame", "TrackingConfig", UIParent, "UIPanelDialogTemplate");
	TrackingConfig:SetSize(340,500);
	TrackingConfig:SetPoint("CENTER");--, anchorpoint, relativeTo, relativePoint);
	TrackingConfig:SetMovable(true);
	TrackingConfig:SetScript("OnMouseDown", TrackingConfig.StartMoving)
	TrackingConfig:SetScript("OnMouseUp", TrackingConfig.StopMovingOrSizing)
	--Set Config Frame Title
	TrackingConfig.Title:SetFontObject("GameFontHighlight");
	TrackingConfig.Title:ClearAllPoints();
	TrackingConfig.Title:SetPoint("TOPLEFT",TrackingConfigTitleBG,"TOPLEFT" , 6, -2);
	TrackingConfig.Title:SetText("Rep Tracking");
	--Set Scroll Frame
	TrackingConfig.ScrollFrame = CreateFrame("ScrollFrame", nil, TrackingConfig, "UIPanelScrollFrameTemplate");
	TrackingConfig.ScrollFrame:SetPoint("TOPLEFT", TrackingConfigDialogBG, "TOPLEFT", 4,-8);
	TrackingConfig.ScrollFrame:SetPoint("BOTTOMRIGHT", TrackingConfigDialogBG, "BOTTOMRIGHT", -25,4);
	TrackingConfig.ScrollChild = CreateFrame("Frame", nil, TrackingConfig.ScrollFrame);
	TrackingConfig.ScrollFrame:SetScrollChild(TrackingConfig.ScrollChild);
	TrackingConfig:Hide();
end

function MyFuncs.Update()	
	if not VariablesLoaded then return end;
	print(#AllFactions)
	print(GetNumFactions())
	local count = 0 
	-- Cycle Through Factions and Populate Frames
	ExpandAllFactionHeaders();
	for i = 1, GetNumFactions() do
		-- Get/Format Rep Data
		local FactionName,_,Standing,minVal,maxVal,curVal,_,_,isHeader = GetFactionInfo(i);
		local barVal = curVal-minVal;
		local barMax = maxVal-minVal;
		if (barMax == 0) then
			barVal = 1;
			barMax = 1;
		end
		-- Create if it does not exist
		if AllFactions[i] == nil then
			AllFactions[i] = {ConfigEntry = nil, TrackingBar = nil};
			--Create Entry Line/Progress Bar
			AllFactions[i].ConfigEntry = CreateFrame("Frame", "Entry", TrackingConfig.ScrollChild, "RepEntryTemplate")
			AllFactions[i].TrackingBar = CreateFrame("StatusBar", nil, REPPER, "RBarTemplate");
			AllFactions[i].TrackingBar:Hide();
			--Saved Variable
			if (RepperSVPC[FactionName] == nil or RepperSVPC[FactionName].id == nil) then
				RepperSVPC[FactionName] = {id = i, checked = false};
			elseif (RepperSVPC[FactionName].id ~= i) then
				RepperSVPC[FactionName].id = i;		
			end
			-- Get check value if Faction is already saved
			AllFactions[i].ConfigEntry.CheckBox:SetChecked(RepperSVPC[FactionName].checked);
			
		end 
		-- Save check value in case of change
		if (RepperSVPC[FactionName] ~= nil) then
			RepperSVPC[FactionName].checked = AllFactions[i].ConfigEntry.CheckBox:GetChecked();
		end
		-- Update Config Entry Name
		AllFactions[i].ConfigEntry.Text:SetText(FactionName);
			
		--If isHeader
		if (isHeader) then
			RepperSVPC[FactionName].checked = false;
			AllFactions[i].ConfigEntry.CheckBox:Hide();
			AllFactions[i].ConfigEntry.Status:Hide();
			AllFactions[i].ConfigEntry.Text:SetPoint("LEFT", 0, 0);
		else
		--If not isHeader
			-- Update Config Entry
			local statusText = format("|cff%2x%2x%2x", FACTION_BAR_COLORS[Standing].r*255, FACTION_BAR_COLORS[Standing].g*255, FACTION_BAR_COLORS[Standing].b*255)..getglobal("FACTION_STANDING_LABEL"..Standing).."|r";
			if (maxVal-minVal ~= 0) then statusText = statusText..":"..barVal.."/"..barMax end
			AllFactions[i].ConfigEntry.Text:SetPoint("LEFT", 10, 0); --Tab Indent
			AllFactions[i].ConfigEntry.Status:Show();
			AllFactions[i].ConfigEntry.Status:SetText(statusText);			
			AllFactions[i].ConfigEntry.CheckBox:Show();
			--AllFactions[i].ConfigEntry.CheckBox:SetChecked(RepperSVPC[FactionName].checked);
			-- Update Tracking Bar
			if (AllFactions[i].ConfigEntry.CheckBox:GetChecked()) then
				AllFactions[i].TrackingBar:Show();
				AllFactions[i].TrackingBar:ClearAllPoints();
				AllFactions[i].TrackingBar:SetPoint("TOPLEFT", REPPER, "TOPLEFT", 11, -(count * 15 + 9));
				AllFactions[i].TrackingBar.Text:SetText(FactionName);
				AllFactions[i].TrackingBar.Status:SetText(maxVal-curVal);
				AllFactions[i].TrackingBar:SetStatusBarColor(FACTION_BAR_COLORS[Standing].r, FACTION_BAR_COLORS[Standing].g, FACTION_BAR_COLORS[Standing].b );
				AllFactions[i].TrackingBar:SetMinMaxValues(0,barMax);
				AllFactions[i].TrackingBar:SetValue(barVal);
				count = count + 1;
			else
				if (AllFactions[i].TrackingBar ~= nil) then
					AllFactions[i].TrackingBar:Hide();
				end
			end
		end
		--Set Anchor
		AllFactions[i].ConfigEntry:SetPoint("TOPLEFT", TrackingConfig.ScrollChild, "TOPLEFT", 0, -((i-1)*20));
	end
	-- Update Frame Sizes
	TrackingConfig.ScrollChild:SetSize(275, GetNumFactions()*20);
	if count == 0 then REPPER:Hide() else REPPER:Show() end;
	REPPER:SetHeight(15 * count + 16);
end

function MyFuncs.SaveCheck(FactionName, isChecked)
	--print(FactionName..":"..tostring(isChecked))
	RepperSVPC[FactionName].checked = isChecked;
end

--mouse entering Item
function MyFuncs.OnEnter(FactionName)
	if not VariablesLoaded then return end;
	local id = RepperSVPC[FactionName].id;
	if (id == nil) then return end;
	local _,_,Standing,minVal,maxVal,curVal,_,_,isHeader = GetFactionInfo(id);
	GameTooltip_SetDefaultAnchor(GameTooltip, UIParent)
	GameTooltip:ClearLines();
	if (isHeader) then
		FactionName = FactionName.." Factions";
	end
	GameTooltip:SetText(FactionName);
	if (not isHeader) then
		GameTooltip:AddLine(format("|cff%2x%2x%2x", FACTION_BAR_COLORS[Standing].r*255, FACTION_BAR_COLORS[Standing].g*255, FACTION_BAR_COLORS[Standing].b*255)..getglobal("FACTION_STANDING_LABEL"..Standing).."|r");
		if ((maxVal-minVal) ~= 0) then
			GameTooltip:AddLine("|cffffffff"..(curVal-minVal).."/"..(maxVal-minVal).."|r");
		end
	end
	GameTooltip:Show();
end

--mouse leaving Item
function MyFuncs.OnLeave()
	GameTooltip:Hide()
end

function Repper__wait(delay, func, ...)
  if(type(delay)~="number" or type(func)~="function") then
    return false;
  end
  if(waitFrame == nil) then
    waitFrame = CreateFrame("Frame","WaitFrame", UIParent);
    waitFrame:SetScript("onUpdate",function (self,elapse)
      local count = #waitTable;
      local i = 1;
      while(i<=count) do
        local waitRecord = tremove(waitTable,i);
        local d = tremove(waitRecord,1);
        local f = tremove(waitRecord,1);
        local p = tremove(waitRecord,1);
        if(d>elapse) then
          tinsert(waitTable,i,{d-elapse,f,p});
          i = i + 1;
        else
          count = count - 1;
          f(unpack(p));
        end
      end
    end);
  end
  tinsert(waitTable,{delay,func,{...}});
  return true;
end

function SlashCmdList.Repper(msg)
	if (msg == 'show' or msg == '') then
		print('Repper: Showing Tracker Config Frame');
		TrackingConfig:Show();
	elseif (msg == 'hide') then
		print('Repper: Hiding Tracker Config Frame');
		TrackingConfig:Hide();
	elseif (msg == 'none') then
		print('Repper: Disabling all tracking');
		ExpandAllFactionHeaders();
		for i = 1, GetNumFactions() do
			AllFactions[i].CheckBox:SetChecked(false);
			local FactionName = GetFactionInfo(i);
			RepperSVPC[FactionName].checked = false;
		end
		MyFuncs.Update()
	else
		if RepperSVPC[msg] ~= nil then print(RepperSVPC[msg].id) else print("Invalid Entry.") end
	end
end


_G[ADDONNAME] = MyFuncs -- put our functions in the global environment under our addon name so we can access them from the .xml as ProfessionHUD.FunctionName